/*
    TCFbECell.h    June 6, 2004.

    Copyright (C) 2003-2004 CFbE Research Group,
    Software Engineering Laboratory,
    Graduate School of Information Science,
    Nara Institute of Science and Technology,
    All rights reserved.

    This program is free software; you can redistribute it and/or modify it
    under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2, (at your option) or
    any later version.

    This program is distributed in the hope that it will be useful, but
    WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with GNU Emacs; see the file COPYING.  If not, write to the
    Free Software Foundation, Inc., 59 Temple Place - Suite 330,
    Boston, MA 02111-1307, USA.
*/
//---------------------------------------------------------------------------
#ifndef TCFbECellH
#define TCFbECellH
//---------------------------------------------------------------------------
#include <Math.hpp>
#include "TCFbEToolkit.h"
//---------------------------------------------------------------------------
class TCFbECell : public TObject
{
public:
    __property double Value = { read=GetValue, write=SetValue, default=0 };
    bool Enabled;
    double    Rank;    // RankCorrelation の計算に使用される領域

    virtual __fastcall TCFbECell(void);                    // コンストラクタ（測定されていないメトリクスを生成する
    virtual __fastcall TCFbECell(double value);            // コンストラクタ（測定されているメトリクスを生成する
    virtual __fastcall TCFbECell(TCFbECell* Source);    // コピーコンストラクタ
    __fastcall ~TCFbECell();                                // デストラクタ
    virtual void __fastcall Assign(TCFbECell* Source);    // this の各値に Source の各値を代入する

protected:
    double    FValue;

    virtual void __fastcall SetValue(double value);
    virtual double __fastcall GetValue();

private:

};

//---------------------------------------------------------------------------
// オーダリングに使用する比較関数
//---------------------------------------------------------------------------
// 降順ソート
// > 0 (正)    Item1 が Item2 より小さい
//   0    Item1 と Item2 が等しい
// < 0 (負)    Item1 が Item2 より大きい
int __fastcall CompareCell(void *Item1, void *Item2)
{
    if (TCFbEToolkit::GetToolkit()->Equals(((TCFbECell*)Item1)->Value, ((TCFbECell*)Item2)->Value)) {
        return 0;
    } else if ( ((TCFbECell*)Item1)->Value < ((TCFbECell*)Item2)->Value ) {
        return 1;
    } else {
        return -1;
    }
}

//---------------------------------------------------------------------------
#endif
